[![build status](https://ci.xterminatestudio.com/projects/1/status.png?ref=master)](https://ci.xterminatestudio.com/projects/1?ref=master)

# Instalación de las dependencias

Antes de nada, instalamos las dependencias en el sistema:

    $ sudo apt install npm
    $ sudo npm install -g bower
    $ sudo npm install -g grunt-cli

Si el sistema operativo es Ubuntu, hay que tener en cuenta que el ejecutable de nodejs se llama 'nodejs', en lugar de 'node' como en otras distribuciones o sistemas operativos.
Para solventar esto y que las aplicaciones que usen el comando 'node' funcionen correctamente, debemos hacer un enlace simbólico:

    $ sudo ln -s /usr/bin/nodejs /usr/bin/node

A continuación, podemos instalar las dependencias del desarrollo del proyecto. En el directorio raíz de la aplicación, ejecutamos:

    $ npm install
    $ bower install

# Ejecución

## Navegador web

Una vez instaladas las dependencias, ejecutamos la aplicación en el navegador mediante el comando:

    $ grunt serve

Para detener el servicio, pulsamos Ctrl+C.

## Dispositivos y emuladores

Para poder ejecutar la aplicación en dispositivos Android es necesario tener instaladas las siguientes herramientas antes de realizar los pasos que se describen a continuación.

    * Oracle JDK 8.
    * Android SDK.

En el caso de iOS, para poder ejecutarlo debemos trabajar en un sistema Mac OS X, y tener instalado y actualizado XCode.

A continuación, añadimos las plataformas en las que queremos ejecutar la aplicación, por ejemplo:

    $ grunt platform:add:android
    $ grunt platform:add:ios

Para ejecutar estos pasos, debemos previamente haber ejecutado la aplicación en el navegador, ya que necesita crear algunos ficheros para reconocerlo como un proyecto cordova.

## Crosswalk

Para usar [Crosswalk](https://crosswalk-project.org/) en lugar del WebView por defecto de Android, es necesario sustituir y compilar librerías de Cordova. Ésto podemos hacerlo ejecutando el script que se encuentra en la carpeta libs. Antes de ejecutarlo, debemos asegurarnos de que las dependencias están instaladas (JDK y Android SDK). El script también asume que en el sistema está instalada una imagen de la versión 19 de Android.

    $ cd libs
    $ ./install-crosswalk.sh

### Comprobar si estamos usando Crosswalk

Para comprobar que se está usando Crosswalk, una vez ejecutado en Android, podemos hacer debug con Chrome usando chrome://inspect, y en la consola, imprimiendo esto:

    navigator.userAgent

La salida, debería ser algo como esto:

    "Mozilla/5.0 (Linux; Android 4.2.2; ZTE V975 Build/JDQ39)
    AppleWebKit/537.36 (KHTML, like Gecko) Chrome/34.0.1847.116
    Mobile Crosswalk/7.36.154.12 Mobile Safari/537.36"

### Android

Para ejecutarlo en un emulador Android:

    $ grunt emulate:android

Para ejecutarlo en un dispositivo Android:

    $ grunt run:android

### iOS

Para ejecutarlo en un emulador iOS:

    $ grunt emulate:ios

Para ejecutarlo en un dispositivo iOS:

    $ grunt run:ios

# Ejecutar tests

Existen dos formas de ejecutar los tests, mediante consola, o en el navegador.

 * Para ejecutarlos en consola:

    $ grunt karma

 * Para ejecutarlos en el navegador, basta con abrir el fichero test.html desde el menú archivo del navegador.
