'use strict';

/**
 * @ngdoc function
 * @name rpsControllers.controller:AppCtrl
 * @description
 * # AppCtrl
 * Controlador utilizado para cerrar la sesión de usuario desde cualquier vista de la aplicación
 */
rpsControllers.controller('AppCtrl', ['$scope', '$state', 'UserService', 'SessionService',
    function($scope, $state, UserService, SessionService) {
        $scope.currentUser = UserService.getCurrentUser();

        /**
         * Cierra la sesión de usuario.
         */
        $scope.logOut = function () {
            // TODO: eliminar dependencia de Parse en los controladores. Solo se debe usar desde servicios.
            Parse.User.logOut();
            SessionService.clearUser();
            $state.transitionTo('login');
        };
    }
]);
