'use strict';

/**
* @ngdoc function
* @name rpsApp.service:ModalService
* @description
* # ModalService
* Servicio usado para mostrar modales en toda la aplicación.
*/
rpsApp.factory('ModalService', ['$ionicModal',

    function ($ionicModal) {
        var service = {};

        /**
         * Muestra un modal
         * @param $scope {Object} Scope con la información del modal a mostrar.
         */
        service.showModal = function ($scope) {
            $ionicModal.fromTemplateUrl('templates/modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
                $scope.modal.show();
            });
        };

        /**
         * Muestra un alert, usando un alert nativo del dispositivo si está disponible, o un modal en caso contrario.
         * @param $scope {Object} Scope con la información del modal a mostrar.
         */
        service.showAlert = function($scope) {
            var callback = $scope.modalInfo.callback || angular.noop;
            if (navigator.notification !== undefined) {
                navigator.notification.alert($scope.modalInfo.message, callback, $scope.modalInfo.title);
            } else {
                service.showModal($scope);
            }
        };

        return service;
    }

]);
