'use strict';

/**
* @ngdoc function
* @name rpsApp.service:UtilsService
* @description
* # UtilsService
* Servicio para utilidades.
*/
rpsApp.factory('UtilsService', [

    function() {

        var service = {};

        /**
         * Genera un identificador con caracteres aleatorios de la longitud especificada.
         * @param length {Number} Longitud del identificador a generar.
         * @return {String} Identificador generado.
         */
        service.makeId = function (length) {
            var text = '';
            var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

            for( var i=0; i < length; i++ ) {
                text += possible.charAt(Math.floor(Math.random() * possible.length));
            }

            return text;
        };

        return service;
    }
]);
