'use strict';

rpsControllers.controller('LoginCtrl', [
    '$scope',
    '$ionicModal',
    '$state',
    '$rootScope',
    '$ionicViewService',
    '$ionicLoading',
    'UserService',
    'ModalService',

    function($scope, $ionicModal, $state, $rootScope, $ionicViewService, $ionicLoading, UserService, ModalService) {
        // Form data for the login modal
        $scope.loginData = {};
        $scope.showValidationMessages = false;

        /**
         * Método para hacer login de un usuario en Parse.
         * @param loginData {Object} Información de login (usuario y contraseña)
         * @param isValid {Boolean} Indica si el formulario es válido o no.
         */
        $scope.logIn = function (loginData, isValid) {
            $scope.showValidationMessages = true;
            if (isValid) {
                $ionicLoading.show({templateUrl: 'templates/loading.html'});

                UserService.login(loginData.username, loginData.password)
                    .then(function () {
                        // deshabilita el botón atrás, borra del historial la página de login
                        $ionicViewService.nextViewOptions({
                            disableBack: true
                        });
                        $ionicLoading.hide();
                        $state.transitionTo('app.wall');
                    })
                    .fail(function (error) {
                        $scope.modalInfo = {
                            title: 'Ups!',
                            message: error
                        };

                        // hide loading
                        $ionicLoading.hide();

                        ModalService.showAlert($scope);
                    });
            }
        };
    }
]);
