'use strict';

rpsControllers.controller('ProfileCtrl', [
    '$scope',
    '$stateParams',
    'UserService',
    'ModalService',

    function($scope, $stateParams, UserService, ModalService) {
        var userId = $stateParams.userId;

        if (userId && userId !== UserService.getCurrentUser().id) {
            $scope.myProfile = false;
            UserService.getUserById($stateParams.userId)
                .then(function (user) {
                    $scope.$apply(function () {
                        $scope.user = user;
                    });
                });
        } else {
            $scope.myProfile = true;
            $scope.user = UserService.getCurrentUser();
        }

        /**
         * Hace 'follow' sobre un usuario, o 'unfollow' si ya seguimos al usuario.
         */
        $scope.follow = function () {
            var prevFollowing = $scope.user.following;

            $scope.user.following = !$scope.user.following;

            if (prevFollowing) {
                UserService.unfollowUser($scope.user.id)
                    .then(function () {
                        window.plugins.toast.showShortBottom('Ya no sigues a ' + $scope.user.username);
                    })
                    .fail(function (error) {
                        $scope.modalInfo = {
                            title: 'Ups!',
                            message: error
                        };
                        ModalService.showAlert($scope);
                    });
            } else {
                UserService.followUser($scope.user.id)
                    .then(function () {
                        window.plugins.toast.showShortBottom('Siguiendo a ' + $scope.user.username);
                    })
                    .fail(function (error) {
                        $scope.modalInfo = {
                            title: 'Ups!',
                            message: error
                        };
                        ModalService.showAlert($scope);
                    });
            }
        };
    }
]);
