'use strict';

rpsControllers.controller('ProfileFollowersCtrl', [
    '$scope',
    '$stateParams',
    'UserService',
    'ModalService',

    function($scope, $stateParams, UserService, ModalService) {
        var promise;

        $scope.loading = true;
        $scope.$parent.profileTab = 'followers';
        if ($stateParams.userId) {
            promise = UserService.getUserFollowers($stateParams.userId);
        } else {
            promise = UserService.getMyFollowers();
            $scope.myProfile = true;
        }

        // obtenemos la lista de followers del usuario.
        promise
            .then(function (followers) {
                $scope.$apply(function () {
                    $scope.loading = false;
                    $scope.followers = followers;
                    if (!followers.length) {
                        $scope.nofollowers = true;
                    }
                });
            })
            .fail(function (error) {
                $scope.modalInfo = {
                    title: 'Ups!',
                    message: error
                };
                ModalService.showAlert($scope);
            });
    }
]);
