'use strict';

rpsControllers.controller('RegisterCtrl', [
    '$scope',
    '$state',
    '$ionicModal',
    '$ionicViewService',
    '$ionicLoading',
    'UserService',
    'ModalService',

    function($scope, $state, $ionicModal, $ionicViewService, $ionicLoading, UserService, ModalService) {
        // Form data for the login modal
        $scope.loginData = {};
        $scope.register = {};
        $scope.showValidationMessages = false;

        /**
         * Registra al usuario en Parse.
         * @param user {Object} Objeto con los datos del usuario a registrar.
         * @param isInvalid {Boolean} Indica si el formulario es válido o no.
         */
        $scope.signUp = function(user, isInvalid) {
            $scope.modalInfo = {};
            $scope.showValidationMessages = true;

            if (!isInvalid) {
                if (user.password === user.repassword) {
                    $ionicLoading.show({templateUrl: 'templates/loading.html'});
                    UserService.register(user)
                        .then(function () {
                            // deshabilita el botón atrás, borra del historial la página de login
                            $ionicViewService.nextViewOptions({
                                disableBack: true
                            });
                            $ionicLoading.hide();
                            $state.transitionTo('app.wall');
                        })
                        .fail(function (error) {
                            $scope.modalInfo.title = 'Ups!';
                            $scope.modalInfo.message = error;

                            $ionicLoading.hide();
                            ModalService.showAlert($scope);
                        });
                } else {
                    $scope.modalInfo.title = 'Contraseñas no coinciden';
                    $scope.modalInfo.message = 'Las contraseñas que has introducido no coinciden.';
                    ModalService.showAlert($scope);
                }
            }
        };
    }
]);
