/*global User*/
'use strict';

/**
* @ngdoc function
* @name diyrApp.service:SessionService
* @description
* # SessionService
* Servicio para manejar la sesión del usuario en la aplicación.
*/
rpsApp.factory('SessionService', [

    function () {
        var service = {};

        service.user = null;

        /**
         * Establece el usuario
         * @param user {Object} Objeto usuario.
         */
        service.setUser = function (user) {
            if (user !== null) {
                service.user = user;
            }
        };

        /**
         * Devuelve el usuario.
         * @return {Object} Usuario.
         */
        service.getUser = function () {
            return service.user;
        };

        /**
         * Limpia el usuario.
         */
        service.clearUser = function () {
            service.user = null;
        };

        return service;
    }

]);
