/*global Parse*/
'use strict';

describe('AddStepCtrl', function () {

    // load the controller's module
    beforeEach(module('rps'));

    var AddStepCtrl,
        scope,
        entryService,
        modalService,
        ionicLoading,
        ionicPopup,
        state,
        stateParams,
        jrCrop,
        entry = {id: 11, title: 'Title', description: 'description', temporalTags: 'tags', imageThumb: 'thumb'},
        step = {description: 'descripcion'};

    // Initialize the controller and a mock scope
    beforeEach(inject(function ($controller, $rootScope) {
        scope = $rootScope.$new();
        entryService = jasmine.createSpyObj('EntryService', ['addStep']);
        modalService = jasmine.createSpyObj('ModalService', ['showAlert']);
        ionicLoading = jasmine.createSpyObj('$ionicLoading', ['show', 'hide']);
        ionicPopup = jasmine.createSpyObj('$ionicPopup', ['confirm']);
        state = jasmine.createSpyObj('$state', ['go']);
        stateParams = {};
        jrCrop = jasmine.createSpyObj('$jrCrop', ['crop']);

        window.plugins = {};
        window.plugins.toast = jasmine.createSpyObj('toast', ['showShortBottom']);

        entryService.addStep.and.returnValue(Parse.Promise.as());

        stateParams.entryId = '11';

        AddStepCtrl = $controller('AddStepCtrl', {
            $scope: scope,
            EntryService: entryService,
            ModalService: modalService,
            $ionicLoading: ionicLoading,
            $ionicPopup: ionicPopup,
            $state: state,
            $stateParams: stateParams,
            $jrCrop: jrCrop
        });
    }));

    it('should save a step using EntryService.addStep if it receives a picData and step params', function () {

        scope.picData = 'data';
        scope.save(step);

        expect(entryService.addStep).toHaveBeenCalled();

        expect(window.plugins.toast.showShortBottom).toHaveBeenCalled();

    });

    it('should call ionicPopup confirm method', function () {

        scope.back(step);

        expect(ionicPopup.confirm).toHaveBeenCalled();
    });

    it('should call getPicture method to take a photo', function () {
        scope.takePic();

        expect(navigator.camera.getPicture).toHaveBeenCalled();
    });


});
