/*global sinon, Parse*/
'use strict';


describe('EntryService', function () {

    var originalParse,
        mockParse,
        mockUtilsService;

    beforeEach(module('rps'));

    beforeEach(function () {
        originalParse = Parse;
        var save = jasmine.createSpy('save').and.callFake(
            function () {
                return originalParse.Promise.as({
                    id: 1,
                    get: function(param) {
                        if (param === 'imageThumb') {
                            return {
                                url: function () { }
                            };
                        }

                        return param;
                    }
                });
            });

        mockParse = sinon.mock({
            initialize: function () {

            },
            Object: {
                extend: function () {
                    return function () {
                        return {
                            set: function () {

                            },
                            save: save
                        };
                    };
                },
                save: save
            },
            User: {
                current: function () {
                    return {get: function () {} };
                }
            },
            File: function () {
                return {
                    save: function () {
                        return originalParse.Promise.as();
                    }
                };
            },
            Query: function () {
                return {
                    get: function () {
                        return {
                            set: function () {},
                            save: save
                        };
                    }
                }
            }
        });

        Parse = mockParse.object;

        mockUtilsService = sinon.stub({
            makeId: function () {}
        });

        mockUtilsService.makeId.returns('12345');

        module(function ($provide) {
            $provide.value('UtilsService', mockUtilsService);
        });
    });

    it('should add an entry', inject(function (EntryService) {

        var entryData = {};

        EntryService.addOrEdit(entryData, '').then(function () {
            expect(Parse.Object.extend()().save).toHaveBeenCalled();
        });

    }));

    /*it('should edit an entry', inject(function (EntryService) {
        var entryData = {};

        EntryService.addOrEdit(entryData, '', 1)
            .then(function () {

            });
    }));*/

    afterEach(function () {
        Parse = originalParse;
    });

});
