'use strict';

describe('AppCtrl', function () {

    // load the controller's module
    beforeEach(module('rps'));

    var AppCtrl,
        scope,
        state,
        userService,
        sessionService,
        mockParse,
        originalParse;

    // Initialize the controller and a mock scope
    beforeEach(inject(function ($controller, $rootScope) {
        scope = $rootScope.$new();
        state = jasmine.createSpyObj('$state', ['transitionTo']);
        userService = jasmine.createSpyObj('UserService', ['getCurrentUser']);
        sessionService = jasmine.createSpyObj('SessionService', ['clearUser']);

        mockParse = {};
        mockParse.User = jasmine.createSpyObj('User', ['logOut']);
        originalParse = Parse;
        Parse = mockParse;

        AppCtrl = $controller('AppCtrl', {
            $scope: scope,
            $state: state,
            UserService: userService,
            SessionService: sessionService
        });
    }));

    afterEach(function () {
        Parse = originalParse;
    });

    it('should call Parse logout', function () {
        scope.logOut();

        expect(mockParse.User.logOut).toHaveBeenCalled();
    });

    it('should call SessionService.clearUser', function () {
        scope.logOut();

        expect(sessionService.clearUser).toHaveBeenCalled();
    });

    it('should call $state.transitionTo', function () {
        scope.logOut();

        expect(state.transitionTo).toHaveBeenCalledWith('login');
    });



});
