/*global sinon*/
'use strict';


describe('ModalService navigator.notification.alert()', function () {

    var mockIonicModal,
        message = 'A message',
        callback = angular.noop,
        title = 'A title';

    beforeEach(module('rps'));

    // load the controller's module
    beforeEach(function () {
        mockIonicModal = sinon.stub({
            fromTemplateUrl: function () {}
        });

        var modalResult = {
            then: function () {
                return {
                    modal: {
                        show: function () {}
                    }
                };
            }
        };

        mockIonicModal.fromTemplateUrl.returns(modalResult);

        module(function ($provide) {
            $provide.value('$ionicModal', mockIonicModal);
        });
    });

    it('should call navigator.notification.alert() when available', inject(function (ModalService, $rootScope) {

        var oldNotification = navigator.notification,
            scope = $rootScope.$new();

        scope.modalInfo = {message: message, title: title, callback: callback};

        navigator.notification = jasmine.createSpyObj('notification', ['alert']);

        ModalService.showAlert(scope);
        expect(navigator.notification.alert).toHaveBeenCalledWith(message, callback, title);

        navigator.notification = oldNotification;

    }));

    it('showAlert should call $ionicModal when navigator.notification.alert() is not available', inject(function (ModalService, $rootScope) {
        var scope = $rootScope.$new();
        scope.modalInfo = {message: message, title: title, callback: callback};

        ModalService.showAlert(scope);

        expect(mockIonicModal.fromTemplateUrl.called).toBeTruthy();
    }));

});
