/*global Parse */
'use strict';

describe('LoginCtrl', function () {

    // load the controller's module
    beforeEach(module('rps'));

    var LoginCtrl,
        scope,
        ionicModal,
        state,
        rootScope,
        ionicViewService,
        ionicLoading,
        userService,
        modalService,
        loginData = {username: 'username', password: 'password'};

    // Initialize the controller and a mock scope
    beforeEach(inject(function ($controller, $rootScope) {
        scope = $rootScope.$new();
        state = jasmine.createSpyObj('$state', ['transitionTo']);
        userService = jasmine.createSpyObj('UserService', ['login']);
        modalService = jasmine.createSpyObj('ModalService', ['showAlert']);
        ionicLoading = jasmine.createSpyObj('$ionicLoading', ['show', 'hide']);
        ionicViewService = jasmine.createSpyObj('$ionicViewService', ['nextViewOptions']);
        rootScope = $rootScope;

        userService.login.and.returnValue(Parse.Promise.as());

        LoginCtrl = $controller('LoginCtrl', {
            $scope: scope,
            $ionicModal: ionicModal,
            $state: state,
            $rootScope: rootScope,
            $ionicViewService: ionicViewService,
            $ionicLoading: ionicLoading,
            UserService: userService,
            ModalService: modalService
        });
    }));

    describe('logIn', function () {
        it('should call UserService.login method', function () {
            scope.logIn(loginData, true);

            expect(userService.login).toHaveBeenCalledWith(loginData.username, loginData.password);
            expect(ionicViewService.nextViewOptions).toHaveBeenCalled();
            expect(state.transitionTo).toHaveBeenCalledWith('app.wall');
        });
    });

});
