/*global Parse, xit */
'use strict';

describe('ProfileCtrl', function () {

    // load the controller's module
    beforeEach(module('rps'));

    var ProfileCtrl,
        scope,
        stateParams,
        userService,
        modalService;

    // Initialize the controller and a mock scope
    beforeEach(inject(function ($controller, $rootScope) {
        scope = $rootScope.$new();
        userService = jasmine.createSpyObj('UserService', ['getCurrentUser', 'getUserById']);
        modalService = jasmine.createSpyObj('ModalService', ['showAlert']);
        stateParams = {userId: 1};

        window.plugins = {};
        window.plugins.toast = jasmine.createSpyObj('toast', ['showShortBottom']);

        userService.getCurrentUser.and.returnValue({id: 2});
        userService.getUserById.and.returnValue(Parse.Promise.as());

        ProfileCtrl = $controller('ProfileCtrl', {
            $scope: scope,
            $stateParams: stateParams,
            UserService: userService,
            ModalService: modalService
        });
    }));

    // TODO: $scope.$apply está haciendo que se hagan get de templates que no se necesitan aquí y
    // hace que este test falle. Hay que revisar el porqué, mientras tanto se omite este test.
    xit('should call getUserById to get user data', function () {
        expect(userService.getUserById).toHaveBeenCalledWith(stateParams.userId);
    });

    describe('follow', function () {
        // TODO: $scope.$apply está haciendo que se hagan get de templates que no se necesitan aquí y
        // hace que este test falle. Hay que revisar el porqué, mientras tanto se omite este test.
        xit('should call followUser', function () {
            scope.user.following = false;
            scope.user.id = 3;

            scope.follow();

            expect(userService.followUser).toHaveBeenCalledWith(3);
        });
    });
    
});
