/*global Parse, xit */
'use strict';

describe('ProfileFollowersCtrl', function () {

    // load the controller's module
    beforeEach(module('rps'));

    var ProfileFollowersCtrl,
        scope,
        stateParams,
        userService,
        modalService,
        controller;

    // Initialize the controller and a mock scope
    beforeEach(inject(function ($controller, $rootScope) {
        scope = $rootScope.$new();
        stateParams = {};
        userService = jasmine.createSpyObj('UserService', ['getUserFollowers', 'getMyFollowers']);
        modalService = jasmine.createSpyObj('ModalService', ['showAlert']);
        controller = $controller;

        userService.getUserFollowers.and.returnValue(Parse.Promise.as());
        userService.getMyFollowers.and.returnValue(Parse.Promise.as());

    }));

    describe('my user', function () {
        // TODO: $scope.$apply está haciendo que se hagan get de templates que no se necesitan aquí y
        // hace que este test falle. Hay que revisar el porqué, mientras tanto se omite este test.
        xit('should get my followers', function (){
            ProfileFollowersCtrl = controller('ProfileFollowersCtrl', {
                $scope: scope,
                $staParams: stateParams,
                UserService: userService,
                ModalService: modalService
            });
            expect(userService.getMyFollowers).toHaveBeenCalled();
        });
    });

    describe('another user', function () {

        // TODO: $scope.$apply está haciendo que se hagan get de templates que no se necesitan aquí y
        // hace que este test falle. Hay que revisar el porqué, mientras tanto se omite este test.
        xit('should get followers of an user', function (){
            stateParams.userId = 1;
            ProfileFollowersCtrl = controller('ProfileFollowersCtrl', {
                $scope: scope,
                $staParams: stateParams,
                UserService: userService,
                ModalService: modalService
            });
            expect(userService.getUserFollowers).toHaveBeenCalledWith(1);
        });
    });

    
});
