/*global Parse */
'use strict';

describe('RegisterCtrl', function () {

    // load the controller's module
    beforeEach(module('rps'));

    var RegisterCtrl,
        scope,
        ionicModal,
        state,
        rootScope,
        ionicViewService,
        ionicLoading,
        userService,
        modalService,
        user = {username: 'username', password: 'password', repassword: 'password'};

    // Initialize the controller and a mock scope
    beforeEach(inject(function ($controller, $rootScope) {
        scope = $rootScope.$new();
        state = jasmine.createSpyObj('$state', ['transitionTo']);
        userService = jasmine.createSpyObj('UserService', ['register']);
        modalService = jasmine.createSpyObj('ModalService', ['showAlert']);
        ionicLoading = jasmine.createSpyObj('$ionicLoading', ['show', 'hide']);
        ionicViewService = jasmine.createSpyObj('$ionicViewService', ['nextViewOptions']);
        rootScope = $rootScope;

        userService.register.and.returnValue(Parse.Promise.as());

        RegisterCtrl = $controller('RegisterCtrl', {
            $scope: scope,
            $ionicModal: ionicModal,
            $state: state,
            $rootScope: rootScope,
            $ionicViewService: ionicViewService,
            $ionicLoading: ionicLoading,
            UserService: userService,
            ModalService: modalService
        });
    }));

    describe('register', function () {
        it('should call UserService.register method if password and repassword are equals', function () {
            scope.signUp(user, false);

            expect(userService.register).toHaveBeenCalledWith(user);
            expect(ionicViewService.nextViewOptions).toHaveBeenCalled();
            expect(state.transitionTo).toHaveBeenCalledWith('app.wall');
        });

        it('should call UserService.register method if password and repassword are not equals', function () {
            user.repassword = 'nopwd';
            scope.signUp(user, false);
            expect(modalService.showAlert).toHaveBeenCalled();
        });
    });

});
