'use strict';

var tests = [

    'spec/entries/services/entry-service.spec.js',
    'spec/rps/services/modal-service.spec.js',
    'spec/rps/services/utils-service.spec.js',

    'spec/entries/add-entry-controller.spec.js',
    'spec/entries/entry-detail-controller.spec.js',
    'spec/entries/add-step-controller.spec.js',
    'spec/rps/app-controller.spec.js',
    'spec/rps/wall-controller.spec.js',
    'spec/rps/search-entries-controller.spec.js',
    'spec/rps/search-users-controller.spec.js',

    'spec/users/login-controller.spec.js',
    'spec/users/register-controller.spec.js',
    'spec/users/profile-controller.spec.js',
    'spec/users/profile-contacts-controller.spec.js',
    'spec/users/profile-entries-controller.spec.js',
    'spec/users/profile-followers-controller.spec.js'
];

var loadJavascriptFile = function (url) {
    return new Promise(function (resolve, reject) {
        var head = document.getElementsByTagName('head')[0],
            script = document.createElement('script');

        script.type = 'text/javascript';

        script.onload = resolve.bind(null, script);

        script.src = url;
        head.appendChild(script);
    });
};

var loadTests = function () {
    return Promise.all(tests.map(function (testFile) {
        return loadJavascriptFile(testFile);
    }));
};
